


export class MenuWidget {
	
	tpl = `
		<div>
			<ul class="menu-items">
				<li class="burger-menu"><a href="javascript:void(0);" [widget]="widget" onclick="widget.toggleMobileMenu();" class="fas fa-bars"></a></li>
				
				<li><a href="{{ appUrl('/') }}">Dashboard</a></li>
				
				<li><a href="{{ appUrl('/customers/') }}">Relaties</a></li>
				
				<!--
				<li><a href="{{ appUrl('/sales/salesplan/') }}">Planbord</a></li>
				
				<li><a href="{{ appUrl('/sales/rental/') }}">Verhuur</a></li>
				
				<li><a href="{{ appUrl('/sales/offer/') }}">Offertes</a></li>
				
				<li><a href="{{ appUrl('/sales/order/') }}">Orders</a></li>
				-->
				<li><a href="{{ appUrl('/contracts/') }}">Contracten</a></li>
				
				<li><a href="{{ appUrl('/contracts/tasks/') }}">Contract taken</a></li>
				
				<li><a href="{{ appUrl('/files/') }}">Bestanden</a></li>
				
				<li ez-if="isAdmin" ><a href="{{ appUrl('/masterdata/') }}">Instellingen</a></li>
			</ul>
		</div>
	`;
	
	mobileMenuClosed = true;
	
	
	init( e ) {
//		console.log(e);
		
		let et = new EzTemplate( e );
		et.loadHtml( this.tpl );
		et.setObject('widget', this);
		et.setVar('isAdmin', toolboxConfig.admin);
		et.build();
		et.render();
		
		window.addEventListener('popstate', function() {
			this.updateMenu();
		}.bind(this));
		
		$(window).on('window-history-pushed', function() {
			this.updateMenu();
		}.bind(this));
		
		this.updateMenu();
		
		$('.menu-items li:not(.burger-menu)').click(function() {
			$('.menu-items').removeClass('show-mobile');
		}.bind(this));
		
		this.handleLogoff();
	}
	
	handleLogoff() {
		if (itxapp.config.desktopMode == false && itxapp.config.userId) {
			$('.logoff-container').removeClass('hidden');
			
			$('#logoff').on('click', function() {
				
				showConfirmation('Afmelden', 'Weet je zeker dat je je wilt afmelden? <label class="signout-all"><input type="checkbox" id="logoffAllSessions" /> <span>Alle sessies afmelden</span></label>', function() {
					
					postUrl( '/service/auth.do', {
						a: 'logoff',
						allsessions: $('#logoffAllSessions').prop('checked') ? 1 : 0
					}).then( async function(e) {
						window.location = appUrl('/');
					});
					
				}.bind(this));
			});
		}
	}
	
	
	updateMenu() {
		$('.menu-items').find('.selected').removeClass('selected');
		
		let pathname = window.location.pathname;
		
		// lookup url with largest href-match :)
		let matchLen = -1;
		let lastMatch = null;
		$('.menu-items').find('a').each(function(index, node) {
			let href = $(node).attr('href');
			
			if ( pathname.startsWith(href) ) {
				if (href.length > matchLen) {
					matchLen = href.length;
					lastMatch = node;
				}
			}
		});
		
		if (lastMatch)
			$(lastMatch).closest('li').addClass('selected');
	};
	
	toggleMobileMenu() {
		if ( $('.menu-items').hasClass('show-mobile') ) {
			$('.menu-items').removeClass('show-mobile');
		}
		else {
			$('.menu-items').addClass('show-mobile');
		}
	}
	
}


