

export class EmailSettingsWidget {
	
	
	
	tpl = `
		<div class="page-header">
			<div class="toolbox">
				<a href="{{appUrl('/masterdata/')}}" class="fa fa-chevron-circle-left"></a>
				<a href="javascript:void(0);" [onclick]="widget.save" class="fa fa-save"></a>
			</div>
			
			<h1>E-mail Instellingen</h1>
		</div>
	
		<span ez-if="settings == null">
			Loading...
		</span>
	
		<form id="frmEmail" ez-if="settings != null">
			<fieldset>
				<legend>SMTP Instellingen</legend>
				
				<ez-text name="fromName" placeholder="Toolbox" label="Afzender naam" [value]="settings.fromName"></ez-text>
				
				<ez-text name="fromEmail" placeholder="info@localhost" label="Afzender e-mail" [value]="settings.fromEmail"></ez-text>
				
				<ez-text name="smtpHost" label="SMTP Server" [value]="settings.smtpHost"></ez-text>
				
				<ez-number name="smtpPort" label="SMTP Port" [value]="settings.smtpPort" min="1" max="65535"></ez-number>
				
				<ez-checkbox name="smtpTls" label="TLS" [checked]="settings.smtpTls"></ez-checkbox>
				
				<ez-text name="smtpUsername" label="Gebruikersnaam" [value]="settings.smtpUsername"></ez-text>
				
				<ez-password name="smtpPassword" label="Wachtwoord" [value]="settings.smtpPassword"></ez-password>
				
				<button id="btnTestMail" [onclick]="widget.sendTestMail">Verstuur test mail</button>
			</fieldset>
			
		
		</form>
	`;
	
	
	container = null;
	settings = null;
	
	ezTpl = null;
	
	init(c) {
		this.container = c;
		
		this.render();
		this.loadSettings();
	}
	
	render() {
		this.ezTpl = new EzTemplate( this.container );
		this.ezTpl.setVar('settings', this.settings);
		this.ezTpl.setObject('widget', this);
		this.ezTpl.loadHtml( this.tpl );
		this.ezTpl.render();
		
	}
	
	loadSettings() {
		postUrl('/service/email/settings.do' )
		.then( async function(e) {
			let json = await e.json();
			this.settings = json.emailSettings;
			
			this.render();
		}.bind(this) );
	}
	
	save() {
		
		let data = serialize2object('#frmEmail');
		data.a = 'save';
		
		postUrl('/service/email/settings.do', data).then( async function(e) {
			let json = await e.json();
			reportUserMessage( 'Wijzigingen opgeslagen' );
		}.bind(this) );
		
	}
	
	
	sendTestMail() {
		showConfirmation('Test mail versturen', 'E-mailadres: <input type="email" name="popup_email" />', function() {
			let e = $('[name=popup_email]').val();
			
			if (validate_email(e) == false) {
				alert('Ongeldig mailadres');
				return false;
			}
			
			let o = serialize2object( '#frmEmail' );
			o.a = 'testMail';
			o.emailAddress = e;
			
			postUrl('/service/', o, {
				callback_success: function(json) {
					
				}.bind(this)
			})
			
			save_state( 'email-settings-test', 'email', e );
		});
		
	}
	
}




