


export class AppSettingsWidget {
	
	tpl = `
		<div class="page-header">
			<div class="toolbox">
				<a href="{{appUrl('/masterdata/')}}" class="fa fa-chevron-circle-left"></a>
				<a href="javascript:void(0);" [onclick]="widget.save" class="fa fa-save"></a>
			</div>
			
			<h1>Instellingen</h1>
		</div>
		
		<span ez-if="settings == null">Loading...</span>
		
		<div ez-if="settings != null">
			<form id="frmSettings">
				<ez-text name="companyName" [value]="settings.companyName" label="Bedrijfsnaam"></ez-text>
			</form>
		</div>
		
	`;
	
	container = null;
	ezTpl = null;
	settings = null;
	
	init(e) {
		this.container = e;
		this.render();
		
		this.loadSettings();
	}
	
	loadSettings() {
		postUrl( '/service/appsettings.do' ).then( async function(e) {
			let json = await e.json();
			this.settings = json.settings;
			this.render();
		}.bind(this) );
	}
	
	save() {
		let d = {};
		d.a = 'save';
		d.companyName = $('#frmSettings input[name=companyName]').val();
		
		postUrl( '/service/appsettings.do', d )
		.then( async function(e) {
			reportUserMessage('Wijzigingen opgeslagen');
			
			gotoRoute( appUrl('/masterdata/appsettings/') );
		}.bind(this) );
	}
		
	
	
	render() {
		this.ezTpl = new EzTemplate( this.container );
		this.ezTpl.setVar('settings', this.settings);
		this.ezTpl.setObject('widget', this);
		this.ezTpl.loadHtml( this.tpl );
		this.ezTpl.render();
		
	}
	
}

