



export class LicenseWidget {
	
	tpl = `
		<div class="page-header page-no-license-check">
			<div class="toolbox">
				<a href="{{appUrl('/masterdata/')}}" class="fa fa-chevron-circle-left"></a>
				<a href="javascript:void(0);" [onclick]="widget.save" class="fa fa-save"></a>
			</div>
			
			<h1>Registratie Instellingen</h1>
		</div>
		
		<span ez-if="loading == true">Loading...</span>
		
		<div ez-if="loading == false">
			<form id="frmLicense">
				<ez-text name="appLicenseCode" [value]="settings.appLicenseCode" label="Registratiecode"></ez-text>
				
				<div class="">{{ settings.licenseMessage}}</div>
				
			</form>
		</div>
		
	`;
	
	container = null;
	ezTpl = null;
	loading = true;
	settings = null;
	
	init(e) {
		this.container = e;
		this.render();
		
		this.loadSettings();
		
		if (getUrlParam('s') == '1') {
			reportUserMessage('Wijzigingen opgeslagen');
		}
	}
	
	loadSettings() {
		postUrl( '/service/license.do', {
			a: 'settings'
		}).then( async function(e) {
			let json = await e.json();
			this.settings = json;
			this.loading = false;
			this.render();
		}.bind(this) );
	}
	
	save() {
		let d = {};
		d.a = 'saveSettings';
		d.appLicenseCode = $('#frmLicense input[name=appLicenseCode]').val();
		
		postUrl( '/service/license.do', d ).then( async function(e) {
			let json = await e.json();
			if (json.validLicense) {
				// valid license => reload...
				window.location = appUrl('/masterdata/license/?s=1');
			}
			else {
				reportUserMessage('Wijzigingen opgeslagen');
				gotoRoute( appUrl('/masterdata/license/') );
			}
		}.bind(this) );
	}
		
	
	
	render() {
		this.ezTpl = new EzTemplate( this.container );
		this.ezTpl.setVar('loading', this.loading);
		this.ezTpl.setVar('settings', this.settings);
		this.ezTpl.setObject('widget', this);
		
		this.ezTpl.loadHtml( this.tpl );
		this.ezTpl.render();
		
	}
	
}

