



export class OfferListWidget {
	
	container = null;
	vats = null;
	
	ezTpl = null;
	
	tpl = `
		<div class="page-header">
			<div class="toolbox">
				<a href="{{appUrl('/sales/offer/edit/')}}" class="fa fa-plus"></a>
			</div>
			
			<h1>Offertes</h1>
		</div>
		
		<div ez-if="offers == null">
			Loading...
		</div>
		<div ez-if="offers != null">
			<table class="table">
				<thead>
					<tr>
						<th>Offerte Nr</th>
						<th>Klant</th>
						<th>Omschrijving</th>
						<th>Bedrag</th>
						<th>Status</th>
						<th>Datum</th>
					</tr>
				</thead>
				<tbody  ez-for="offers" ez-item="o" class="tbody-offers">
					<tr [onclick]="widget.editOffer" class="pointer" offer-id="{{o.offerId}}">
						<td>{{o.offerNumber}}</td>
						<td>{{o.customerName}}</td>
						<td>{{o.subject}}</td>
						<td>{{o.totalCalculatedPrice}}</td>
						<td>{{o.offerStatus}}</td>
						<td>{{ format_date(o.offerDate, {dmy:true})}}</td>
					</tr>
				</tbody>
					
				<tbody ez-if="offers.length == 0">
					<tr>
						<td colspan="6" class="no-results">
							Geen resultaten gevonden
						</td>
					</tr>
				</tbody>
			</table>
		</div>
	`;
	
	
	editOffer(evt, tr) {
		let oid = tr.getAttribute('offer-id');
		
		gotoRoute( appUrl('/sales/offer/edit/?id='+oid) );
	}


	render() {
		this.ezTpl = new EzTemplate( this.container );
		this.ezTpl.setVar('offers', this.offers);
		this.ezTpl.setObject('widget', this);
		this.ezTpl.loadHtml( this.tpl );
		this.ezTpl.render();
		
	}
	
	
	
	searchOffers() {
		postUrl( '/service/sales/offer.do', {
			a: 'search'
		}).then( async function(e) {
			let json = await e.json();
			if (json.error) {
				return showErrorWidget( json );
			}
			
			this.offers = json.offers;
			this.render();
			
		}.bind(this) );
	}
	
	
	init(e) {
		this.container = e;
		
		this.render();
		
		this.searchOffers();
	}

}

