



export class PricetypeListWidget {
	
	container = null;
	pricetypes = null;
	
	ezTpl = null;
	
	tpl = `
		<div class="page-header">
			<div class="toolbox">
				<a href="{{appUrl('/masterdata/')}}" class="fa fa-chevron-circle-left"></a>
				<a href="{{appUrl('/masterdata/sales/pricetype/edit/')}}" class="fa fa-plus"></a>
			</div>
			
			<h1>Slotplan Prijstypes</h1>
		</div>
		
		<div ez-if="pricetypes == null">
			Loading...
		</div>
		<div ez-if="pricetypes != null">
			<table class="table">
				<thead>
					<tr>
						<th></th>
						<th>Naam</th>
						<th>Actief</th>
						<th>Laatst bewerkt</th>
					</tr>
				</thead>
				<tbody  ez-for="pricetypes" ez-item="p" class="tbody-pricetypes">
					<tr [onclick]="widget.editPricetype" class="pointer" slotplan-pricetype-id="{{p.slotplanPricetypeId}}">
						<td style="width: 50px;"><i class="fa fa-up-down sort-handle"></i></td>
						<td>{{p.name}}</td>
						<td>{{p.active ? 'Ja' : 'Nee' }}</td>
						<td>{{ format_datetime(p.edited, {dmy: true}) }}</td>
					</tr>
				</tbody>
					
				<tbody ez-if="pricetypes.length == 0">
					<tr>
						<td colspan="4" class="no-results">
							Geen resultaten gevonden
						</td>
					</tr>
				</tbody>
			</table>
		</div>
	`;
	
	
	editPricetype(evt, tr) {
		let id = tr.getAttribute('slotplan-pricetype-id');
		
		gotoRoute( appUrl('/masterdata/sales/pricetype/edit/?id='+id) );
	}


	render() {
		this.ezTpl = new EzTemplate( this.container );
		this.ezTpl.setVar('pricetypes', this.pricetypes);
		this.ezTpl.setObject('widget', this);
		this.ezTpl.loadHtml( this.tpl );
		this.ezTpl.render();

		$(this.container).find('.tbody-pricetypes').sortable({
			handle: '.sort-handle',
			update: function() {
				this.saveSort();
			}.bind(this)
		});
		
	}
	
	saveSort() {
		let ids = [];
		$('.tbody-pricetypes tr').each(function(index, node) {
			let id = $(node).attr('slotplan-pricetype-id');
			ids.push(id);
		});
		
		postUrl( '/service/sales/pricetype.do', {
			a: 'updateSort',
			ids: ids.join(',')
		}).then( async function(e) {
				showToastMessage('Volgorde opgeslagen');
		}.bind(this));
	}
	
	
	loadPricetypes() {
		postUrl( '/service/sales/pricetype.do')
		.then( async function(e) {
			let json = await e.json();
			if (json.error) {
				return showErrorWidget( json );
			}
			
			this.pricetypes = json.pricetypes;
			this.render();
			
		}.bind(this) );
	}
	
	
	init(e) {
		this.container = e;
		
		this.render();
		
		this.loadPricetypes();
	}

}

